unit NuclearToolkit;
interface
uses Windows, Messages, SysUtils, Variants, Classes,
 Graphics, Controls, Forms,
 Dialogs, StdCtrls, ExtCtrls, Math;


type
Tinfo_group = record
 nam: string;
 tag: integer;
end;

TNamVal = record
 nam: string;
 val: integer;
end;

var
 RazdelName: string;
 ar_var: array of TNamVal;

function ReverseString(s: string): string;
function GetLastNam(Nam: string): string;
function FixIntToStr(Num: Integer): string;
function IsDigitChar(c1: Char): Boolean;
function GetStr_LastNumber(s: string): string;
function GetButLastNam(Nam: string): string;
function IsEqual(s1, s2: string): Boolean;

procedure add_var(s1: string);
procedure v(s1: string; val: integer); overload;
function v(s1: string): integer; overload;

procedure Group_Panel(f: TForm);
procedure Repaint_panel(f: TForm; pan: TPanel);

implementation


function ReverseString(s: string): string;
var  i: integer;
begin
 Result := '';
 if (Trim(s) <> '') then
  for i := Length(s) downto 1 do
   Result := Result + s[i];
end;

function GetLastNam(Nam: string): string;
var
 i, i_pointer: Integer;
begin
 Nam := ReverseString(Nam);
 i_pointer := Length(Nam);
 for i:=1 to Length(Nam) do
  if (Nam[i] = RazdelName) then
   begin
    i_pointer := i;
    break;
   end;

 Nam := ReverseString(Nam);
 Result := '';
 for i:=(Length(Nam) - i_pointer + 2) to Length(Nam) do
  Result := Result + Nam[i];
end;

function FixIntToStr(Num: Integer): string;
begin
 if (Num < 0)
 then Result := '-'
 else Result := '';
 Result := Result + IntToStr(Abs(Num div 10)) + '.' + IntToStr(Abs(Num mod 10));
end;

function IsDigitChar(c1: Char): Boolean;
begin
 Result := false;
 if ( (c1 >= '0') and (c1 <= '9') )
 then Result := true;
end;

function GetStr_LastNumber(s: string): string;
var  i, index: Integer;
begin
 index := Length(s);
 for i:=Length(s) downto 1 do
  if not IsDigitChar(s[i]) then
   begin
    index := i + 1;
    break;
   end;
 Result := Copy(s, index, Length(s) - index + 1);
end;

function IsBit(b1, b2: Integer): Boolean;
begin
 Result := false;
 if ((b1 and b2) <> 0) then Result := true;
end;

function GetButLastNam(Nam: string): string;
var  i, i_pointer: Integer;
begin
 Nam := ReverseString(Nam);
 i_pointer := Length(Nam);
 for i:=1 to Length(Nam) do
  if (Nam[i] = RazdelName) then
   begin
    i_pointer := i;
    break;
   end;

 Nam := ReverseString(Nam);
 Result := '';
 for i:=1 to (Length(Nam) - i_pointer) do
  Result := Result + Nam[i];
end;


function IsEqual(s1, s2: string): Boolean;
begin
 Result := (s1 = s2);
end;


procedure add_var(s1: string);
var
 Exist: Boolean;
 i, leng: integer;
begin
 leng := length(ar_var);
 Exist := false;
 for i:=0 to (leng - 1) do
  if (s1 = ar_var[i].nam) then
   begin
    Exist := true;
    break;
   end;

 if not Exist then
  begin
   setlength(ar_var, leng + 1);
   ar_var[leng].nam := s1;
   ar_var[leng].val := 0;
  end;
end;

procedure v(s1: string; val: integer); overload;
var  i, leng: integer;
begin
 leng := length(ar_var);
 for i:=0 to (leng - 1) do
  if (s1 = ar_var[i].nam) then
  begin
   ar_var[i].val := val;
   break;
  end;
end;

function v(s1: string): integer; overload;
var  i, leng: integer;
begin
 Result := 0;
 leng := length(ar_var);
 for i:=0 to (leng - 1) do
  if (s1 = ar_var[i].nam) then
  begin
   Result := ar_var[i].val;
   break;
  end;
end;


procedure Group_Panel(f: TForm);
var
 Exist: Boolean;
 i, j, tek_tag: Integer;
 s1, s2: string;

 ar_panel: array of Tinfo_group;

 procedure Add_Panel(s1: string);
 var  leng: integer;
 begin
  leng := length(ar_panel);
  setlength(ar_panel, leng + 1);
  ar_panel[leng].nam := s1;
  ar_panel[leng].tag := 0;
 end;

begin

 for i:=0 to (f.ComponentCount - 1) do
  if (f.Components[i] is TPanel) then
   begin
    s1 := f.Components[i].Name;
    Add_Panel(s1);
    (f.Components[i] as TPanel).Tag := 0;
   end;

 tek_tag := 1;
 for i:=0 to (length(ar_panel) - 2) do
  begin
   s1 := ar_panel[i].nam;
   s1 := GetButLastNam(s1);

   Exist := false;
   for j:=i+1 to (length(ar_panel) - 1) do
    if (ar_panel[j].tag = 0) then
     begin
      s2 := ar_panel[j].nam;
      s2 := GetButLastNam(s2);

      if IsEqual(s1, s2) then
       begin
        Exist := true;
        ar_panel[i].tag := tek_tag;
        ar_panel[j].tag := tek_tag;
       end;
     end;

   if Exist then Inc(tek_tag);
  end;

 for i:=0 to (f.ComponentCount - 1) do
  if (f.Components[i] is TPanel) then
   begin
    s1 := f.Components[i].Name;

    for j:=0 to (length(ar_panel) - 1) do
     if (s1 = ar_panel[j].nam) then
      begin
       f.Components[i].Tag := ar_panel[j].tag;
       (f.Components[i] as TPanel).Hint := IntToStr( ar_panel[j].tag );
       break;
      end;
   end;

end;


procedure Repaint_panel(f: TForm; pan: TPanel);
var
 Exist: Boolean;
 val0, val, j, i: Integer;
 s_Nam, s_ButLast, s_Last: string;
 Col: TColor;  bc: TBevelCut;
begin
 s_Nam := pan.Name;
 s_ButLast := GetButLastNam(s_Nam);
 v(s_ButLast, StrToInt( GetStr_LastNumber(s_Nam) ));

 for i:=0 to (f.ComponentCount - 1) do
  if (f.Components[i] is TPanel) then
   begin
    s_Nam := f.Components[i].Name;
    s_ButLast := GetButLastNam(s_Nam);

    Exist := false;
    for j:=0 to (length(ar_var) - 1) do
     if (s_ButLast = ar_var[j].nam) then
      begin
       val := ar_var[j].val;
       Exist := true;
       break;
      end;

    if Exist then
     begin
      s_Last := GetLastNam(s_Nam);
      val0 := StrToInt(s_Last);
      if (val = val0)
      then  begin   Col := clNavy; bc := bvLowered;  end
      else  begin   Col := clGray; bc := bvRaised;  end;
      (f.Components[i] as TPanel).Color := Col;
      (f.Components[i] as TPanel).BevelOuter := bc;
     end;

   end;
end;

end.
