unit Unit1;
interface
uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
 Dialogs, StdCtrls, ExtCtrls, NuclearToolkit;

type
  TForm1 = class(TForm)
    Button_step: TButton;
    Button_start: TButton;
    Timer1: TTimer;
    group_visib: TGroupBox;
    visib_1: TPanel;
    visib_2: TPanel;
    group_speed: TGroupBox;
    speed_1000: TPanel;
    speed_50: TPanel;
    speed_5: TPanel;
    group_angle: TGroupBox;
    angle_4500: TPanel;
    angle_3000: TPanel;
    angle_1947: TPanel;
    angle_1448: TPanel;
    Image1: TImage;
    procedure Func_Start;
    procedure FormCreate(Sender: TObject);
    procedure Button_startClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure visib_1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure speed_1000Click(Sender: TObject);
    procedure Button_stepClick(Sender: TObject);
    procedure angle_4500Click(Sender: TObject);
  public
    procedure Show_Pole;
    procedure Show_History;
  end;

var
 Form1: TForm1;

 start: Boolean;

 Pole, History: Array[0..100] of Array[0..100] of Integer;
 Pole_x, Pole_y: integer;

 kx, ky,
 xx, yy,
 xx_old, yy_old,
 tek_xx, tek_yy,
 naprav_x, naprav_y
 : Integer;

 steps: Array[0..10] of TPoint;
 steps_point, steps_count: Integer;


implementation
{$R *.dfm}


procedure TForm1.Show_Pole;
var
 x, y: integer;
 Color: TColor;
begin
 for y:=0 to (Pole_y - 1) do
 for x:=0 to (Pole_x - 1) do
  begin
   Color := clBtnFace;
   if (x = tek_xx) and (y = tek_yy)
   then Color := clRed;

   Canvas.Pen.Color := clBlack;
   Canvas.Brush.Color := Color;
   Canvas.Rectangle(x * kx, y * ky,   (x + 1) * kx, (y + 1) * ky);
  end;
end;

procedure TForm1.Show_History;
var
 x, y: integer;
 Color: TColor;
begin
 for y:=0 to (Pole_y - 1) do
 for x:=0 to (Pole_x - 1) do
  begin
   Color := clBtnFace;
   if (History[x][y] > 0)
   then Color := clRed;

   Canvas.Pen.Color := clBlack;
   Canvas.Brush.Color := Color;
   Canvas.Rectangle(x * kx, y * ky,   (x + 1) * kx, (y + 1) * ky);
  end;
end;


procedure Invert(var naprav: integer);
begin
 if (naprav = 1)
 then naprav := -1
 else naprav := 1;
end;


procedure TForm1.Func_Start;
var  Was_Otrazh: Boolean;
label Again;
begin

Again:
 xx_old := xx;
 yy_old := yy;
 xx := xx + naprav_x * steps[steps_point].X;
 yy := yy + naprav_y * steps[steps_point].Y;

 Was_Otrazh := false;
 if (xx < 0) then  begin  Invert(naprav_x);  Was_Otrazh := true;  end;
 if (yy < 0) then  begin  Invert(naprav_y);  Was_Otrazh := true;  end;
 if (xx >= Pole_x) then  begin  Invert(naprav_x);  Was_Otrazh := true;  end;
 if (yy >= Pole_y) then  begin  Invert(naprav_y);  Was_Otrazh := true;  end;

 if Was_Otrazh then
  begin
   xx := xx_old;
   yy := yy_old;
   goto Again;
  end;

 tek_xx := xx;
 tek_yy := yy;
 steps_point := (steps_point + 1) mod steps_count;

 Inc( History[tek_xx][tek_yy] );

 if v('visib') = 1
 then Show_Pole
 else Show_History;
end;


procedure init;
var  x, y: integer;
begin
 kx := 10;
 ky := kx;
 Pole_x := 39;
 Pole_y := 40;

 xx := 0;
 yy := 0;
 naprav_x := 1;
 naprav_y := 1;
 for y:=0 to (Pole_y - 1) do
 for x:=0 to (Pole_x - 1) do
  History[x][y] := 0;

 steps_point := 0;
 start := false;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 init;

 setlength(ar_var, 0);
 add_var('visib');
 add_var('speed');
 add_var('angle');

 v('visib', 1);
 v('speed', 5);
 v('angle', 4500);

 RazdelName := '_';
 Group_Panel(Form1);

 angle_4500Click(angle_4500);
end;
procedure TForm1.FormActivate(Sender: TObject);
begin
 Repaint_panel(Form1, visib_1);
end;


procedure TForm1.Button_startClick(Sender: TObject);
begin
 start := not start;

 if start
 then Button_start.Caption := 'stop'
 else Button_start.Caption := 'start';
 
 Timer1.Interval := v('speed');
 Timer1.Enabled := start;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Func_Start;
end;

procedure TForm1.Button_stepClick(Sender: TObject);
begin
 Timer1.Enabled := false;
 Func_Start;
end;

procedure TForm1.visib_1Click(Sender: TObject);
begin
 Repaint_panel(Form1, Sender as TPanel);
end;
procedure TForm1.speed_1000Click(Sender: TObject);
begin
 Repaint_panel(Form1, Sender as TPanel);
 Timer1.Interval := v('speed');
 Timer1.Enabled := true;
end;
procedure TForm1.angle_4500Click(Sender: TObject);
begin
 Repaint_panel(Form1, Sender as TPanel);

 steps_point := 0;

 if v('angle') = 4500 then
  begin
   steps[0].X := 1;
   steps[0].Y := 1;
   steps_count := 1;
  end;

 if v('angle') = 3000 then
  begin
   steps[0].X := 1;
   steps[0].Y := 0;
   steps[1].X := 1;
   steps[1].Y := 1;
   steps_count := 2;
  end;

 if v('angle') = 1947 then
  begin
   steps[0].X := 1;
   steps[0].Y := 0;
   steps[1].X := 1;
   steps[1].Y := 0;
   steps[2].X := 1;
   steps[2].Y := 1;
   steps_count := 3;
  end;

 if v('angle') = 1448 then
  begin
   steps[0].X := 1;
   steps[0].Y := 0;
   steps[1].X := 1;
   steps[1].Y := 0;
   steps[2].X := 1;
   steps[2].Y := 0;
   steps[3].X := 1;
   steps[3].Y := 1;
   steps_count := 4;
  end;
end;

end.

